﻿@using Services;
@inject ConvertService convertService
@inject IncomeTaxService incomeTaxService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>Income Tax</h6>
        </div>
        <div class="form-group">
            <table class="table table-sm">
                <tbody>
                    <tr>
                        <td>Salary income per year</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerYear" checked="@((AmountSelectType == AmountSelection.PerYear))" @onchange="__e => AmountSelectType = AmountSelection.PerYear" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.IncomeFromSalary" @oninput="((ChangeEventArgs __e) => DataInput.IncomeFromSalary = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerYear))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Salary income per month</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerMonth" checked="@((AmountSelectType == AmountSelection.PerMonth))" @onchange="__e => AmountSelectType = AmountSelection.PerMonth" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerMonth" @oninput="((ChangeEventArgs __e) => AmountPerMonth = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerMonth))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Tax Scheme</td>
                        <td>
                            <InputSelect class="form-control form-control-sm" @bind-Value="DataInput.TaxScheme">
                                @foreach (var item in Enum.GetValues(typeof(TaxScheme)))
                                {
                                    <option value="@item">@item</option>
                                }
                            </InputSelect>
                        </td>
                    </tr>
                    <tr>
                        <td>Tax Payer</td>
                        <td>
                            <InputSelect class="form-control form-control-sm" @bind-Value="DataInput.TaxPayerType">
                                @foreach (var item in Enum.GetValues(typeof(TaxPayerType)))
                                {
                                    <option value="@item">@item</option>
                                }
                            </InputSelect>
                        </td>
                    </tr>
                    @if (DataInput.TaxPayerType == TaxPayerType.Individual)
                    {
                        <tr>
                            <td>Age</td>
                            <td>
                                <InputSelect class="form-control form-control-sm" @bind-Value="AgeString">
                                    <option value="50">Below 60</option>
                                    <option value="70">60 - 80</option>
                                    <option value="90">Above 80</option>
                                </InputSelect>
                            </td>
                        </tr>
                    }
                    @if (DataInput.TaxScheme == TaxScheme.OldScheme)
                    {
                        <tr>
                            <td>HRA</td>
                            <td>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.HRA" @oninput="((ChangeEventArgs __e) => DataInput.HRA = ToDouble(__e?.Value))" maxlength="6" />
                            </td>
                        </tr>
                        <tr>
                            <td>Rent paid</td>
                            <td>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.RentPaid" @oninput="((ChangeEventArgs __e) => DataInput.RentPaid = ToDouble(__e?.Value))" maxlength="6" />
                            </td>
                        </tr>
                        <tr>
                            <td>Is Living in Metro Cities</td>
                            <td>
                                <input type="checkbox" @bind="DataInput.IsLivingInMetroCities">
                            </td>
                        </tr>
                        <tr>
                            <td>Section 80C</td>
                            <td>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.Section80C" @oninput="((ChangeEventArgs __e) => DataInput.Section80C = ToDouble(__e?.Value))" maxlength="6" />
                                <sup>PPF deposit + ELSS investment + LIC premium + EPF deducted by employer</sup>
                            </td>
                        </tr>
                        <tr>
                            <td>Section 80D</td>
                            <td>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.Section80D" @oninput="((ChangeEventArgs __e) => DataInput.Section80D = ToDouble(__e?.Value))" maxlength="6" />
                                <sup>Medical insurance premium</sup>
                            </td>
                        </tr>
                        <tr>
                            <td>Section 80TTA</td>
                            <td>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.Section80TTA" @oninput="((ChangeEventArgs __e) => DataInput.Section80TTA = ToDouble(__e?.Value))" maxlength="6" />
                                <sup>Savings account interest</sup>
                            </td>
                        </tr>
                        <tr>
                            <td>Section 24B</td>
                            <td>
                                <input class="form-control form-control-sm mr-sm-2" value="@DataInput.Section24B" @oninput="((ChangeEventArgs __e) => DataInput.Section24B = ToDouble(__e?.Value))" maxlength="6" />
                            </td>
                        </tr>
                    }
                </tbody>
            </table>
        </div>
        <div class="form-group">
            <table class="table table-hover table-sm">
                <tbody>
                    <tr>
                        <td><b>Deductions</b></td>
                        <td></td>
                    </tr>
                    @foreach (var item in DataOutput.Deductions)
                    {
                        <tr>
                            <td>@item.Key</td>
                            <td>@ToIndianCurrency(item.Value)</td>
                        </tr>
                    }
                    <tr>
                        <td>Total deductions</td>
                        <td>@ToIndianCurrency(DataOutput.TotalDeductions)</td>
                    </tr>
                    <tr>
                        <td>Taxable income</td>
                        <td>@ToIndianCurrency(DataOutput.TaxableIncome)</td>
                    </tr>
                    <tr>
                        <td><b>Tax amount details</b></td>
                        <td></td>
                    </tr>
                    @foreach (var item in DataOutput.TaxAmountSplits)
                    {
                        <tr>
                            <td>@item.Key</td>
                            <td>@ToIndianCurrency(item.Value)</td>
                        </tr>
                    }
                    <tr>
                        <td><b>Net tax amount</b></td>
                        <td>@ToIndianCurrency(DataOutput.NetTaxAmount)</td>
                    </tr>
                    <tr>
                        <td>Surcharge @@ @DataOutput.SurchargePercentage %</td>
                        <td>@ToIndianCurrency(DataOutput.SurchargeAmount)</td>
                    </tr>
                    <tr>
                        <td>Rebate 87A</td>
                        <td>@ToIndianCurrency(DataOutput.Rebate87A)</td>
                    </tr>
                    <tr>
                        <td>Health & education cess @@ @DataOutput.CessPercentage %</td>
                        <td>@ToIndianCurrency(DataOutput.CessAmount)</td>
                    </tr>
                    <tr>
                        <td><b>Tax amount</b></td>
                        <td>@ToIndianCurrency(DataOutput.TaxAmount)</td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private const int MonthInYear = 12;

    private ITDataInput DataInput { get; set; } = new ITDataInput();
    private ITDataOutput DataOutput { get; set; } = new ITDataOutput();

    private enum AmountSelection { PerYear, PerMonth };

    private AmountSelection AmountSelectType { get; set; } = AmountSelection.PerMonth;
    private double AmountPerMonth { get; set; } = 0;

    private string AgeString
    {
        get { return DataInput.Age.ToString(); }
        set { DataInput.Age = Convert.ToInt32(value); }
    }

    private double ToDouble(object value) => convertService.ToDouble(value);

    private string ToIndianCurrency(double value) => convertService.ToIndianCurrency(value, false, false);

    protected override bool ShouldRender()
    {
        RefreshValues();
        return base.ShouldRender();
    }

    private void RefreshValues()
    {
        CalculateAmount();
        CalculateTax();
    }

    private void CalculateAmount()
    {
        switch (AmountSelectType)
        {
            case AmountSelection.PerYear:
                if (DataInput.IncomeFromSalary > 0)
                {
                    AmountPerMonth = Math.Round(DataInput.IncomeFromSalary / MonthInYear, 2);
                }
                else AmountPerMonth = 0;
                break;
            case AmountSelection.PerMonth:
                if (AmountPerMonth > 0)
                {
                    DataInput.IncomeFromSalary = AmountPerMonth * MonthInYear;
                }
                else DataInput.IncomeFromSalary = 0;
                break;
            default:
                throw new NotImplementedException();
        }
    }

    private void CalculateTax()
    {
        DataOutput = incomeTaxService.CalculateTax(DataInput);
    }
}
